routes/web.php
<?php

use App\Http\Controllers\admin\CommonController;
use App\Http\Controllers\Admin\RoleController;
use App\Http\Controllers\admin\UsersController;
use App\Http\Controllers\admin\ProductsController;
use App\Http\Controllers\admin\OrderController;
use App\Http\Controllers\admin\PaymentsController;
use App\Http\Controllers\Auth\LoginController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\SettingsController;
use App\Http\Controllers\HomeController;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();
Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::get('/orders', [App\Http\Controllers\HomeController::class, 'orders'])->name('orders');
Route::get('/payments', [App\Http\Controllers\HomeController::class, 'payments'])->name('payments');
Route::get('/items', [App\Http\Controllers\HomeController::class, 'items'])->name('items');
Route::get('/settings', [App\Http\Controllers\HomeController::class, 'settings'])->name('settings');
Route::get('/darkmode-switch/{mode}', [App\Http\Controllers\HomeController::class, 'darkmodeSwitch'])->name('darkmode-switch');
Route::post('user-login', [LoginController::class, 'userLogin'])->name('user-login');
Route::post('user-signup', [LoginController::class, 'userSignup'])->name('user-signup');

// Admin Routes
Route::get('/products', [App\Http\Controllers\HomeController::class, 'products'])->name('products');
Route::post('/create-product', [App\Http\Controllers\HomeController::class, 'createProduct'])->name('create-product');
Route::get('/all-orders', [App\Http\Controllers\HomeController::class, 'allOrders'])->name('all-orders');
Route::post('/create-order', [App\Http\Controllers\HomeController::class, 'createOrder'])->name('create-order');
Route::prefix('admin')->group(function () {
    Route::group(['middleware' => 'auth:web'], function () {
        Route::get('/settings', [HomeController::class, 'index']);
        Route::match(['get', 'post'], '/change-password', [SettingsController::class, 'change_password'])->name('change_password');
        Route::post('/update-settings', [SettingsController::class, 'update']);
        Route::resource('roles', RoleController::class);
        Route::resource('users', UsersController::class);
        Route::get('delete/{route}/{id}', [CommonController::class, 'delete'])->name('delete');
        // Route::resource('products', ProductsController::class);
        Route::post('get-product-value', [ProductsController::class, 'getProductValue'])->name('getProductValue');
        Route::resource('orders', OrderController::class);
        Route::resource('payments', PaymentsController::class);
        Route::post('get-append-rows', [OrderController::class, 'getAppendedRows'])->name('getAppendedRows');
        Route::get('getProducts', [ProductsController::class, 'getProducts'])->name('getProducts');
        Route::post('app-order', [OrderController::class, 'appOrder'])->name('app-order');
    });
});

app/Http/Controllers/admin/PaymentsController.php
<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use App\Models\Transaction;
use App\Models\User;
use App\Models\UserTransaction;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Validator;
use Yajra\DataTables\Facades\DataTables;

class PaymentsController extends Controller
{
    /** 
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    { 
        if ($request->ajax()) {
            $data = UserTransaction::select('user_transactions.id','user_transactions.date','user_transactions.amount','user_transactions.type','user_transactions.status','user_transactions.remarks','users.profile_photo','name')->leftjoin('users','users.id','=','user_transactions.user_id');
            if(Auth::user()->type=='user'){
                $data = $data->where('user_id',Auth::id());
            }
            return DataTables::of($data)
                    ->addIndexColumn()
                    ->addColumn('action', function ($row) {
                        $button = '<button type="button" data-href="'.route('payments.edit',$row->id).'" data-keyboard="false" data-backdrop="static" class="btn btn-xs btn-primary edit_button" data-container=".modal_class"><i class="fa fa-edit"></i></button>&nbsp';
                        $button .='<button data-href="'.route('delete',['payments',$row->id]).'" class="btn btn-xs btn-danger btn-modal"><i class="fa fa-trash"></i></button>';
                        return $button;
                    })
                    ->addColumn('profile_photo',function ($row) {
                        if($row->profile_photo){
                            return '<img src="'.asset($row->profile_photo).'" style="height:50px" alt="'.$row->name.'"> '.$row->name;
                        }else{
                            return '<img src="'.asset('img/user2.png').'" style="height:50px" alt="'.$row->name.'"> '.$row->name;
                        }
                        
                    })
                    ->addColumn('status',function($row){
                        if($row->status==2){
                            return '<span class="badge badge-warning">PENDING</span>';
                        }else{
                            return '<span class="badge badge-success">CONFIRMED</span>';
                        }
                    })
                    ->filter(function ($instance) use ($request) {
                        if (!empty($request->get('search'))) {
                             $instance->where(function($w) use($request){
                                $search = $request->get('search');
                                $w->Where('type', 'LIKE', "%$search%");
                            });
                        }
                    })
                    ->rawColumns(['status','action','profile_photo'])
                    ->make(true);
        }
        return view('admin.payments.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {   
        $users = User::where('status',1)->get();
        return view('admin.payments.create')->with(compact('users'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if(Auth::user()->type=='admin'){
            $rules = ['user_id'=> 'required','status'=>'required'];
        }
        $rules = [
            'amount'         => 'required|integer',    
            'remarks'         => 'required'
        ];
        $messages = [
            'amount.required'    => 'Name Required'
        ];
        $validator = Validator::make(request()->all(), $rules, $messages);
        if ($validator->fails()) {
            return response()->json(['success' => false, 'msg' => $validator->errors()->first()]);
        }
        try {
            $payment = new UserTransaction();
            $payment->transaction_id = 1;
            $payment->date = now();
            $payment->amount = $request->amount;
            $payment->remarks = $request->remarks;
            $payment->type = 'credit';
            if(Auth::user()->type=='admin'){
                $payment->user_id = $request->user_id;
                $payment->status = $request->status;
            }else{
                $payment->user_id = Auth::id();
                $payment->status = 2;
            }
            $payment->save();
            return ['success' => true,'msg' => "succussfully added"];
        } catch (\Exception $e) {
            return ['success' => false,'msg' => $e->getMessage()];
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        if (request()->ajax()) {
            $users = User::where('status',1)->get();
            $payment = UserTransaction::find($id); 
            return view('admin.payments.edit')->with(compact('users','payment'));
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    { 
        if (request()->ajax()) {
            if(Auth::user()->type=='admin'){
                $rules = ['user_id'=> 'required','status'=>'required'];
            }
            $rules = [
                'amount'         => 'required|integer',    
                'remarks'         => 'required'
            ];
            $messages = [
                'amount.required'    => 'Name Required'
            ];
            $validator = Validator::make(request()->all(), $rules, $messages);
            if ($validator->fails()) {
                return response()->json(['success' => false, 'msg' => $validator->errors()->first()]);
            }
            try {
                $payment = UserTransaction::findOrFail($id); 
                $payment->transaction_id = 1;
                $payment->amount = $request->amount;
                $payment->remarks = $request->remarks;
                $payment->type = 'credit';
                if(Auth::user()->type=='admin'){
                    $payment->user_id = $request->user_id;
                    $payment->status = $request->status;
                }else{
                    $payment->user_id = Auth::id();
                    $payment->status = 2;
                }
                $payment->save();
                
                return ['success' => true,'msg' =>'successfully updated'];
            } catch (\Exception $e) {
                return ['success' => false, 'msg' => 'Something went wrong, please try again'];
            }
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {   
        if (request()->ajax()) {
            try {
                $payment = Transaction::findOrFail($id);
                $payment->delete();
                return response()->json(['success' => true,'msg' =>'successfully deleted']);
            } catch (\Exception $e) {
                return response()->json(['success' => false,'msg' => $e->getMessage()]);
            }
        }
    }
}

resources/views/admin/payments/create.blade.php
<div class="modal-dialog" role="document">
    <div class="modal-content">
        <form method="post" action="{{route('payments.store')}}" accept-charset="UTF-8" id="createForm">
            @csrf
            <div class="modal-header">
                <h4 class="modal-title">ADD PAYMENTS</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
            </div>
        
            <div class="modal-body">
                <div class="row">
                    @if (Auth::user()->type=='admin')
                        <div class="col-md-12">
                            <div class="form-group">
                                <label for="name" class="control-label">PAYMENT FOR:*</label>
                                <select class="form-control select2" name="user_id">
                                    <option value="">SELECT</option>
                                    @foreach ($users as $item)
                                        <option value="{{$item->id}}" @if(Auth::id()==$item->id) selected @endif>{{$item->name}}</option>
                                    @endforeach
                                </select>
                            </div>
                        </div>
                    @endif
                    <div class="col-md-12">
                        <div class="form-group">
                            <label for="name" class="control-label">PAYMENT AMOUNT:*</label>
                            <input class="form-control" placeholder="PAYMENT AMOUNT" autocomplete="off" name="amount" type="text">
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-group">
                            <label for="name" class="control-label">REMARKS:*</label>
                            <textarea class="form-control" placeholder="REMARKS" autocomplete="off" name="remarks"></textarea>
                        </div>
                    </div>
                    @if (Auth::user()->type=='admin')
                        <div class="col-md-12">
                            <div class="form-group">
                                <label for="name">STATUS:*</label>
                                <select class="form-control" name="status">
                                    <option value="1">CONFIRMED</option>
                                    <option value="2">PENDING</option>
                                </select>
                            </div>
                        </div>
                    @endif
               </div> 
        
            <div class="modal-footer">
                <button type="submit" class="btn btn-primary save_button">Save</button>
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </form>
  </div><!-- /.modal-content -->
</div><!-- /.modal-dialog -->
<script>
    $(document).on('click','.add-product',function(e){
            var table = $("#product_table");
            var count = $("#product_table tbody tr").length;
            var count_table_tbody_tr = $("#attr_row_count").val();
            var row_id = (Number(count_table_tbody_tr) + 1);
            $.ajax({
                type: "POST",
                url: '{{route("getProducts")}}',
                data: {
                    "_token": "{{ csrf_token() }}",
                },
                success: function(response) {
                    // $('#product_value_id_'+row).html(response);
                    html = '<tr id="row_'+row_id+'"><td><select name="product_id[]" id="product_id_'+row_id+'" class="form-control select2"  style="width:100%" onchange="getAttributeValue('+row_id+')">'+response+'</select></td>' +
                    '<td><select name="product_value_id[]" class="form-control select2" style="width:100%" id="product_value_id_'+row_id+'" required><option value="">SELECT</option></select></td>' +
                    '<td><a class="btn btn-danger remove-product" onclick="removeRow('+row_id+')"><i class="fa fa-trash"></i></a></td>' +
                    '</tr>';
                    if (count >= 1) {
                        $("#product_table tbody tr:last").after(html);
                    } else {
                        $("#product_table tbody").html(html);
                    }
                    $('#product_id_'+row_id).html(response);
                },
            });
            $("#attr_row_count").val(row_id);
        });
function removeRow(tr_id){
    $("#product_table tbody tr#row_"+tr_id).remove();
}
</script>

resources/views/admin/payments/edit.blade.php
<div class="modal-dialog" role="document">
    <div class="modal-content">
        <form method="POST" action="{{route('payments.update',$payment->id)}}" accept-charset="UTF-8" id="edit_form">
            <input name="_method" type="hidden" value="PUT">
            @csrf
            <div class="modal-header">
                <h4 class="modal-title">EDIT PAYMENTS</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
            </div>
            <div class="modal-body">
                <div class="row">
                    @if (Auth::user()->type=='admin')
                        <div class="col-md-12">
                            <div class="form-group">
                                <label for="name" class="control-label">PAYMENT FOR:*</label>
                                <select class="form-control select2" name="user_id">
                                    <option value="">SELECT</option>
                                    @foreach ($users as $item)
                                        <option value="{{$item->id}}" @if($payment->user_id==$item->id) selected @endif>{{$item->name}}</option>
                                    @endforeach
                                </select>
                            </div>
                        </div>
                    @endif
                    <div class="col-md-12">
                        <div class="form-group">
                            <label for="name" class="control-label">PAYMENT AMOUNT:*</label>
                            <input class="form-control" placeholder="PAYMENT AMOUNT" value="{{$payment->amount}}" autocomplete="off" name="amount" type="text">
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-group">
                            <label for="name" class="control-label">REMARKS:*</label>
                            <textarea class="form-control" placeholder="REMARKS" autocomplete="off" name="remarks">{{$payment->remarks}}</textarea>
                        </div>
                    </div>
                    @if (Auth::user()->type=='admin')
                        <div class="col-md-12">
                            <div class="form-group">
                                <label for="name">STATUS:*</label>
                                <select class="form-control" name="status">
                                    <option value="1" @if ($payment->status==1) selected @endif>CONFIRMED</option>
                                    <option value="2" @if ($payment->status==2) selected @endif>PENDING</option>
                                </select>
                            </div>
                        </div>
                    @endif
                </div>
            </div>
            <div class="modal-footer">
                <button type="submit" class="btn btn-primary save_button">UPDATE</button>
                <button type="button" class="btn btn-default" data-dismiss="modal">CLOSE</button>
            </div>
        </form>
    </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->

resources/views/admin/payments/index.blade.php
@include('admin.layouts.sidebar')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <button type="button" class="btn btn-primary btn-modal" data-backdrop="static" data-keyboard="false" data-href="{{route('payments.create')}}" data-container=".modal_class">
              <i class="fa fa-plus"></i> ADD</button>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="{{url('admin')}}">HOME</a></li>
                <li class="breadcrumb-item active">OREDRS</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <!-- general form elements -->
            @include('admin.layouts.session')
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">PAYMENTS</h3>
                </div>
                <div class="card-body">
                    <div id="example2_wrapper" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12">
                                <table class="table table-bordered table-striped data-table">
                                    <thead>
                                        <tr> 
                                            <th>DATE</th>
                                            <th>USER</th>
                                            <th>AMOUNT</th>
                                            <th>TYPE</th>
                                            <th>STATUS</th>
                                            <th>REMARKS</th>
                                            <th>ACTION</th>
                                        </tr>
                                    </thead>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
          </div>
        </div>
      </div>
    </section>
</div>
<div class="modal fade modal_class" tabindex="-1" role="dialog" aria-labelledby="gridSystemModalLabel"></div>
@include('admin.layouts.footer')
<script >
    $( document ).ready(function() {
        //DATA TABLE LOAD STARTS HERE
        var table = $('.data-table').DataTable({
        processing: true,
        serverSide: true,
        lengthMenu: [[25, 50, 100, 200, -1], [25, 50, 100, 200, "All"]],
        pageLength : 25,
        dom: "<'row'<'col-sm-2'l><'col-sm-7 text-center'B><'col-sm-3'f>><'row'<'col-sm-12'tr>><'row'<'col-sm-6'i><'col-sm-6'p>>",
        buttons: ["copy", "csv", "excel", "pdf", "print", "colvis"],
        ajax: {
          url: "{{ route('payments.index') }}",
          data: function (d) {
                d.search = $('input[type="search"]').val();
            }
        }, 
        columns: [
            {data: 'date', name: 'date'},
            {data: 'profile_photo', name: 'profile_photo'},
            {data: 'amount', name: 'amount'},
            {data: 'type', name: 'type'}, 
            {data: 'status', name: 'status'},
            {data: 'remarks', name: 'remarks'},
            {data: 'action', name: 'action', orderable: false, searchable: false},
        ],
      });
      //DATA TABLE LOAD END HERE

      //CREATE FORM APPEND TO modal_class AND POST ACTIONS
      $(document).unbind('submit').on('submit', 'form#createForm', function(e){
      e.preventDefault();
      $(this).find('button[type="submit"]').attr('disabled', true);
      var data = $(this).serialize();
      $.ajax({
          method: "post",
          url: $(this).attr("action"),
          dataType: "json",
          data: data,
          success:function(result){
              if(result.success == true){
                $('div.modal_class').modal('hide');
                  toastr.success(result.msg);
                  $('.data-table').DataTable().ajax.reload();
              }else{
                    toastr.error(result.msg);
                    $('.save_button').attr('disabled', false);
              }
          }
      });
    });

    //EDIT FORM APPEND TO modal_class AND POST ACTIONS
    $(document).on('click', 'button.edit_button', function() {
        $('div.modal_class').load($(this).data('href'), function() {
            $(this).modal('show');
            $('form#edit_form').submit(function(e) {
                $(this).find('button[type="submit"]').attr('disabled', true);
                e.preventDefault();
                var data = $(this).serialize();
                $.ajax({
                    method: 'POST',
                    url: $(this).attr('action'),
                    dataType: 'json',
                    data: data,
                    success: function(result) {
                        if (result.success === true) {
                            $('div.modal_class').modal('hide');
                            toastr.success(result.msg);
                            $('.data-table').DataTable().ajax.reload();
                        } else {
                            toastr.error(result.msg);
                            $('.save_button').attr('disabled', false);
                        }
                    },
                });
            });
        });
    });
    });

    $("#mastersNav").addClass('active');
    $("#statesNav").addClass('active');
   </script>
   @include('admin.layouts.scripts')